/* goosee00.c contains support functions, equates,	 */
/* and data declarations for C source code generated	 */
/* by GOOSEE.						 */
/* Put them into your project in whatever way you wish	 */
/* -- you might like to #include this file into whatever */
/* source file has your main() function.		 */

/* EQUATES */
#define TIMEGRAN 100
#define INTOFF	 //statement to turn off interrupts
#define INTON	 //statement to turn on interrupts
#define THEEND	 return 0
#define ISREND	 return


/* GLOBAL DATA REQUIRED TO SUPPORT ASYNC MESSAGING	 */
/* This will support up to 8 async wires ...		 */
U16  asyncmsgs=0;


/* FUNCTIONS REQUIRED TO SUPPORT ASYNC MESSAGING	 */
/* ismsg() and postmsg() support async wires. This will  */
/* work across all of a diagram, even if a number of C	 */
/* files have been generated from various parts of it.	 */
/* -- as long as "asyncmsgs" is visible to ismsg() and	 */
/* postmsg().						 */
/* Note also, ISRs can use async messaging, as long as	 */
/* you give some thought to use of INTON and INTOFF in	 */
/* the functions.					 */

void postmsg(U8 i) {
  U16 xx;
    xx = 1;
    xx = xx << i;  //move flag to correct bit-position.
    INTOFF;	//only need to do this if following statement doesn't compile
		//to a single instruction...
      asyncmsgs = asyncmsgs | xx;	  //set the flag.
    INTON;
  return;
}

bit ismsg(U8 i) {
  U16 xx;
    xx = asyncmsgs >> i;		//get flag into bit0.
    xx = xx & 01
    if(xx) {
    xx = xx << i;	//move logic-1 into correct bit position.
    INTOFF;		//some cpus and optimising compilers will not need to turn off
			//interrupts, as following will be atomic, ie, one instruction...
      asyncmsgs = asyncmsgs ^ xx;		//clr the bit
    INTON;
    return TRUE;
  }
  return FALSE;
}
